unit p_01_invoicingEcoSpace;

interface

uses
  System.Threading,
  Borland.Eco.Services,
  Borland.Eco.UmlCodeAttributes,
  Borland.Eco.Handles,
  Package_1Unit, Borland.Eco.Persistence;

type
  [EcoSpace]
  [EcoSpacePackage(TypeOf(Package_1Unit.Package_1))]
  Tp_01_invoicingEcoSpace = class(Borland.Eco.Handles.DefaultEcoSpace)
    class var fTypeSystemProvider: ITypeSystemService;
    class var fTypeSystemProviderLock: Tobject;
  strict protected
    function GetTypeSystemProvider: ITypeSystemService; override;
  public
    constructor Create;
    class constructor Create;
    class function GetTypeSystemService: ITypeSystemService; static;
    procedure UpdateDatabase;
    function get_PersistenceService: IPersistenceService;
    property PersistenceService: IPersistenceService read get_PersistenceService;
    function get_DirtyListService: IDirtyListService;
    property DirtyListService: IDirtyListService read get_DirtyListService;
    function get_UndoService: IUndoService;
    property UndoService: IUndoService read get_UndoService;
    function get_TypeSystemService: ITypeSystemService;
    property TypeSystemService: ITypeSystemService read get_TypeSystemService;
    function get_OclService: IOclService;
    property OclService: IOclService read get_OclService;
    function get_ObjectFactoryService: IObjectFactoryService;
    property ObjectFactoryService: IObjectFactoryService read get_ObjectFactoryService;
    function get_VariableFactoryService: IVariableFactoryService;
    property VariableFactoryService: IVariableFactoryService read get_VariableFactoryService;
 
  strict private
    PersistenceMapperXml1: Borland.Eco.Persistence.PersistenceMapperXml;
    procedure InitializeComponent; end;

  [assembly: RuntimeRequired(TypeOf(Tp_01_invoicingEcoSpace))]

implementation
{$AUTOBOX ON}

constructor Tp_01_invoicingEcoSpace.Create;
begin
  inherited Create;
  InitializeComponent;
  // TODO: Add any constructor code here
end;

class constructor Tp_01_invoicingEcoSpace.Create;
begin
  fTypeSystemProviderLock := TObject.Create;
end;

class function Tp_01_invoicingEcoSpace.GetTypeSystemService: ITypeSystemService;
begin
  if not Assigned(fTypeSystemProvider) then
  begin
    try
      Monitor.Enter(fTypeSystemProviderLock);
      if not Assigned(fTypeSystemProvider) then
        fTypeSystemProvider := MakeTypeService(typeOf(Tp_01_invoicingEcoSpace));
    finally
      Monitor.Exit(fTypeSystemProviderLock);
    end;
  end;
  Result := fTypeSystemProvider;
end;

function Tp_01_invoicingEcoSpace.GetTypeSystemProvider: ITypeSystemService;
begin
  Result := Tp_01_invoicingEcoSpace.GetTypeSystemService;
end;

procedure Tp_01_invoicingEcoSpace.UpdateDatabase;
begin
  if Assigned(PersistenceService) and Assigned(DirtyListService) then
    PersistenceService.UpdateDatabaseWithList(DirtyListService.AllDirtyObjects);
end;

function Tp_01_invoicingEcoSpace.get_PersistenceService: IPersistenceService;
begin
  Result := GetEcoService(typeof(IPersistenceService)) as IPersistenceService;
end;

function Tp_01_invoicingEcoSpace.get_DirtyListService: IDirtyListService;
begin
  Result := GetEcoService(typeof(IDirtyListService)) as IDirtyListService;
end;

function Tp_01_invoicingEcoSpace.get_UndoService: IUndoService;
begin
  Result := GetEcoService(typeof(IUndoService)) as IUndoService;
end;

function Tp_01_invoicingEcoSpace.get_TypeSystemService: ITypeSystemService;
begin
  Result := GetEcoService(typeof(ITypeSystemService)) as ITypeSystemService;
end;

function Tp_01_invoicingEcoSpace.get_OclService: IOclService;
begin
  Result := GetEcoService(typeof(IOclService)) as IOclService;
end;

function Tp_01_invoicingEcoSpace.get_ObjectFactoryService: IObjectFactoryService;
begin
  Result := GetEcoService(typeof(IObjectFactoryService)) as IObjectFactoryService;
end;

function Tp_01_invoicingEcoSpace.get_VariableFactoryService: IVariableFactoryService;
begin
  Result := GetEcoService(typeof(IVariableFactoryService)) as IVariableFactoryService;
end;

procedure Tp_01_invoicingEcoSpace.InitializeComponent;
begin
  Self.PersistenceMapperXml1 := Borland.Eco.Persistence.PersistenceMapperXml.Create;
  // 
  // PersistenceMapperXml1
  // 
  Self.PersistenceMapperXml1.FileName := 'save_invoicing.xml';
  // 
  // Tp_01_invoicingEcoSpace
  // 
  Self.PersistenceMapper := Self.PersistenceMapperXml1;
end;

end.
